type op = Add | Sub | Mult | Div | Equal | Neq | Less | Leq | Greater | Geq | And | Or | Concat

type expr = 
		LiteralInteger of int
	| LiteralString of string
	| LiteralBool of bool
	| LiteralFloat of float
	| Id of string
	| Binop of expr * op * expr
	| Assign of string * expr
	| Call of string * expr list
	| Noexpr

type stmt = 
		Block of stmt list
	| Expr of expr
	| Return of expr
	| If of expr * stmt * stmt
	| For of expr * expr * expr * stmt
	| While of expr * stmt

type func_decl = {
		fname: string;
		formals : string list;
		locals : string list;
		body : stmt list;
	}

type program = string list * func_decl list